Loading...
Searching...
No Matches
itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType > Class Template Reference

`#include <itkGenericMultiResolutionPyramidImageFilter.h>`

## Detailed Description

template<class TInputImage, class TOutputImage, class TPrecisionType = double>
class itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >

Framework for creating images in a multi-resolution pyramid.

GenericMultiResolutionPyramidImageFilter provides a generic framework to to create a image pyramid according to a user defined multi-resolution rescale and smoothing schedules.

The multi-resolution rescale schedule is specified in terms of shrink factors at each multi-resolution level for each dimension

The rescale schedule is stored as an unsigned int matrix. An element of the table can be access via the double bracket notation: schedule[level][dimension] For example: 8 4 4 4 4 2

is a rescale schedule for two computation level. In the first (coarest) level the image is reduce by a factor of 8 in the column dimension, factor of 4 in the row dimension and factor of 4 in the slice dimension. In the second level, the image is reduce by a factor of 4 in the column dimension, 4 is the row dimension and 2 in the slice dimension.

The method SetNumberOfLevels() set the number of computation levels in the pyramid. This method will allocate memory for the multi-resolution rescale schedule table. This method generates defaults tables with the starting shrink factor for all dimension set to 2^(NumberOfLevel - 1) All factors are halved for all subsequent levels. For example if the number of levels was set to 4, the default table is: 8 8 8 4 4 4 2 2 2 1 1 1

The user can get a copy of the rescale schedule via GetRescaleSchedule() They may make alteration and reset it using SetRescaleSchedule()

To generate each output image, recursive Gaussian smoothing is performed using a SmoothingRecursiveGaussianImageFilter.

The user can make alteration on smoothing schedule via SetSmoothingSchedule() For example, for 4 levels smoothing schedule would be: 3 4 5 2 2 2 0 1 2 0 0 0

In the first level all sigma are set to the same value 2 across each axis. Sigma is measured in the units of image spacing. Use different values along each axis if you would like perform nonidentical smoothing (see level 1) Although for the level 2 no smoothing will be performed because all sigma values are equal zeros. For the last level 3 smoothing will be performed with sigma 0 for x axis.

The default smoothing schedule is derived from the rescale schedule, where each element is computed as: 0.5 * rescale_factor * image_spacing.

The user can get a copy of the schedule via GetSmoothingSchedule()

The smoothed image is then downsampled using a ResampleImageFilter or ShrinkImageFilter depending on SetUseShrinkImageFilter().

When this filter is updated, NumberOfLevels outputs are produced. The N'th output correspond to the N'th level of the pyramid.

The user can influence whether or not rescale schedule or smoothing schedule will be used via SetRescaleScheduleToUnity() and SetSmoothingScheduleToZero() methods.

The GenericMultiResolutionPyramidImageFilter provides direct control to compute only single level of the pyramid via SetCurrentLevel() and SetComputeOnlyForCurrentLevel() methods.

Author
  Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands

This implementation was taken from elastix (http://elastix.dev/).

Note
  This work was funded by the Netherlands Organisation for Scientific Research (NWO NRG-2010.02 and NWO 639.021.124).

See also
  SmoothingRecursiveGaussianImageFilter
  ResampleImageFilter
  ShrinkImageFilter

Definition at line 117 of file itkGenericMultiResolutionPyramidImageFilter.h.

Inheritance diagram for itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | RescaleFactorArrayType = SigmaArrayType
using | RescaleScheduleType = ScheduleType
using | ScalarRealType = typename NumericTraits<PixelType>::ScalarRealType
using | Self = GenericMultiResolutionPyramidImageFilter
using | SigmaArrayType = FixedArray<ScalarRealType, Self::ImageDimension>
using | SmoothingScheduleType = vnl_matrix<ScalarRealType>
using | SpacingType = typename Superclass::InputImageType::SpacingType
using | Superclass = MultiResolutionPyramidImageFilter<TInputImage, TOutputImage>
using | SuperSuperclass = typename Superclass::Superclass

## Public Member Functions

virtual void | ComputeOnlyForCurrentLevelOff ()
virtual void | ComputeOnlyForCurrentLevelOn ()
virtual const char * | GetClassName () const
virtual bool | GetComputeOnlyForCurrentLevel () const
virtual const unsigned int & | GetCurrentLevel ()
const RescaleScheduleType & | GetRescaleSchedule () const
virtual const SmoothingScheduleType & | GetSmoothingSchedule ()
| ITK_DISALLOW_COPY_AND_MOVE (GenericMultiResolutionPyramidImageFilter)
| itkStaticConstMacro (ImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
virtual void | SetComputeOnlyForCurrentLevel (const bool _arg)
virtual void | SetCurrentLevel (unsigned int level)
void | SetNumberOfLevels (unsigned int num) override
virtual void | SetRescaleSchedule (const RescaleScheduleType &schedule)
virtual void | SetRescaleScheduleToUnity ()
void | SetSchedule (const ScheduleType &schedule) override
virtual void | SetSmoothingSchedule (const SmoothingScheduleType &schedule)
virtual void | SetSmoothingScheduleToZero ()

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

void | GenerateData () override
void | GenerateInputRequestedRegion () override
void | GenerateOutputInformation () override
void | GenerateOutputRequestedRegion (DataObject *output) override
| GenericMultiResolutionPyramidImageFilter ()
void | PrintSelf (std::ostream &os, Indent indent) const override
void | ReleaseOutputs ()
| ~GenericMultiResolutionPyramidImageFilter () override=default

## Protected Attributes

bool | m_ComputeOnlyForCurrentLevel {}
unsigned int | m_CurrentLevel {}
SmoothingScheduleType | m_SmoothingSchedule {}
bool | m_SmoothingScheduleDefined {}

## Private Types

using | ImageToImageFilterDifferentTypes = ImageToImageFilter<InputImageType, OutputImageType>
using | ImageToImageFilterSameTypes = ImageToImageFilter<OutputImageType, OutputImageType>
using | SmootherType = SmoothingRecursiveGaussianImageFilter<InputImageType, OutputImageType>

## Private Member Functions

bool | AreRescaleFactorsAllOnes (const RescaleFactorArrayType &rescaleFactorArray) const
bool | AreSigmasAllZeros (const SigmaArrayType &sigmaArray) const
bool | ComputeForCurrentLevel (const unsigned int level) const
void | DefineShrinkerOrResampler (const bool sameType, const RescaleFactorArrayType &shrinkFactors, const OutputImagePointer &outputPtr, typename ImageToImageFilterSameTypes::Pointer &rescaleSameTypes, typename ImageToImageFilterDifferentTypes::Pointer &rescaleDifferentTypes)
double | GetDefaultSigma (const unsigned int level, const unsigned int dim, const unsigned int *factors, const SpacingType &spacing) const
void | GetShrinkFactors (const unsigned int level, RescaleFactorArrayType &shrinkFactors) const
void | GetSigma (const unsigned int level, SigmaArrayType &sigmaArray) const
bool | IsRescaleUsed () const
bool | IsSmoothingUsed () const
void | SetSmoothingScheduleToDefault ()
int | SetupShrinkerOrResampler (const unsigned int level, typename SmootherType::Pointer &smoother, const bool sameType, const InputImageConstPointer &input, const OutputImagePointer &outputPtr, typename ImageToImageFilterSameTypes::Pointer &rescaleSameTypes, typename ImageToImageFilterDifferentTypes::Pointer &rescaleDifferentTypes)
bool | SetupSmoother (const unsigned int level, typename SmootherType::Pointer &smoother, const InputImageConstPointer &input)

## Member Typedef Documentation

## ConstPointer

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ConstPointer = SmartPointer<const Self>

Definition at line 128 of file itkGenericMultiResolutionPyramidImageFilter.h.

## ImageToImageFilterDifferentTypes

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ImageToImageFilterDifferentTypes = ImageToImageFilter<InputImageType, OutputImageType>

private

Definition at line 289 of file itkGenericMultiResolutionPyramidImageFilter.h.

## ImageToImageFilterSameTypes

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ImageToImageFilterSameTypes = ImageToImageFilter<OutputImageType, OutputImageType>

private

Typedefs for shrinker or resample. If smoother has not been used, then we have to use InputImageType to OutputImageType, otherwise OutputImageType to OutputImageType.

Definition at line 288 of file itkGenericMultiResolutionPyramidImageFilter.h.

## Pointer

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::Pointer = SmartPointer<Self>

Definition at line 127 of file itkGenericMultiResolutionPyramidImageFilter.h.

## RescaleFactorArrayType

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::RescaleFactorArrayType = SigmaArrayType

Definition at line 157 of file itkGenericMultiResolutionPyramidImageFilter.h.

## RescaleScheduleType

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::RescaleScheduleType = ScheduleType

Definition at line 153 of file itkGenericMultiResolutionPyramidImageFilter.h.

## ScalarRealType

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ScalarRealType = typename NumericTraits<PixelType>::ScalarRealType

Definition at line 149 of file itkGenericMultiResolutionPyramidImageFilter.h.

## Self

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::Self = GenericMultiResolutionPyramidImageFilter

Standard class typedefs.

Definition at line 124 of file itkGenericMultiResolutionPyramidImageFilter.h.

## SigmaArrayType

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SigmaArrayType = FixedArray<ScalarRealType, Self::ImageDimension>

Define the type for the sigma array.

Definition at line 156 of file itkGenericMultiResolutionPyramidImageFilter.h.

## SmootherType

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SmootherType = SmoothingRecursiveGaussianImageFilter<InputImageType, OutputImageType>

private

Typedef for smoother. Smooth always happens first, then only from InputImageType to OutputImageType is possible.

Definition at line 282 of file itkGenericMultiResolutionPyramidImageFilter.h.

## SmoothingScheduleType

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SmoothingScheduleType = vnl_matrix<ScalarRealType>

SmoothingScheduleType typedef support.

Definition at line 152 of file itkGenericMultiResolutionPyramidImageFilter.h.

## SpacingType

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SpacingType = typename Superclass::InputImageType::SpacingType

Definition at line 147 of file itkGenericMultiResolutionPyramidImageFilter.h.

## Superclass

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::Superclass = MultiResolutionPyramidImageFilter<TInputImage, TOutputImage>

Definition at line 125 of file itkGenericMultiResolutionPyramidImageFilter.h.

## SuperSuperclass

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

using itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SuperSuperclass = typename Superclass::Superclass

Definition at line 126 of file itkGenericMultiResolutionPyramidImageFilter.h.

## Constructor & Destructor Documentation

## GenericMultiResolutionPyramidImageFilter()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GenericMultiResolutionPyramidImageFilter | ( |  | ) |

protected

## ~GenericMultiResolutionPyramidImageFilter()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::~GenericMultiResolutionPyramidImageFilter | ( |  | ) |

override protected default

## Member Function Documentation

## AreRescaleFactorsAllOnes()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::AreRescaleFactorsAllOnes | ( | const RescaleFactorArrayType & | rescaleFactorArray | ) | const

private

Returns true if all elements of rescaleFactorArray are ones, otherwise return false.

## AreSigmasAllZeros()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::AreSigmasAllZeros | ( | const SigmaArrayType & | sigmaArray | ) | const

private

Returns true if all elements of sigmaArray are zeros, otherwise return false.

## ComputeForCurrentLevel()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ComputeForCurrentLevel | ( | const unsigned int | level | ) | const

private

Checks whether we have to compute anything based on m_ComputeOnlyForCurrentLevel and m_CurrentLevel.

## ComputeOnlyForCurrentLevelOff()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ComputeOnlyForCurrentLevelOff | ( |  | ) |

virtual

## ComputeOnlyForCurrentLevelOn()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ComputeOnlyForCurrentLevelOn | ( |  | ) |

virtual

## DefineShrinkerOrResampler()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::DefineShrinkerOrResampler | ( | const bool | sameType,
|  | const RescaleFactorArrayType & | shrinkFactors,
|  | const OutputImagePointer & | outputPtr,
|  | typename ImageToImageFilterSameTypes::Pointer & | rescaleSameTypes,
|  | typename ImageToImageFilterDifferentTypes::Pointer & | rescaleDifferentTypes )

private

Defines Shrink or Resample filters.

## GenerateData()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GenerateData | ( |  | ) |

override protected

Generate the output data.

## GenerateInputRequestedRegion()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GenerateInputRequestedRegion | ( |  | ) |

override protected

Overwrite the Superclass implementation: no padding required.

## GenerateOutputInformation()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GenerateOutputInformation | ( |  | ) |

override protected

GenericMultiResolutionPyramidImageFilter may produce images which are of different resolution and different pixel spacing than its input image. As such, GenericMultiResolutionPyramidImageFilter needs to provide an implementation for GenerateOutputInformation() in order to inform the pipeline execution model. The original documentation of this method is below.

See also
  ProcessObject::GenerateOutputInformaton().

## GenerateOutputRequestedRegion()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GenerateOutputRequestedRegion | ( | DataObject * | output | ) |

override protected

Given one output whose requested region has been set, this method sets the requested region for the remaining output images. The original documentation of this method is below.

See also
  ProcessObject::GenerateOutputRequestedRegion().

## GetClassName()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual const char * itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in elastix::FixedGenericPyramid< TElastix >, elastix::MovingGenericPyramid< TElastix >, elastix::OpenCLFixedGenericPyramid< TElastix >, and elastix::OpenCLMovingGenericPyramid< TElastix >.

## GetComputeOnlyForCurrentLevel()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetComputeOnlyForCurrentLevel | ( |  | ) | const

virtual

## GetCurrentLevel()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual const unsigned int & itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetCurrentLevel | ( |  | ) |

virtual

Get the current multi-resolution level.

## GetDefaultSigma()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

double itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetDefaultSigma | ( | const unsigned int | level,
|  | const unsigned int | dim,
|  | const unsigned int * | factors,
|  | const SpacingType & | spacing ) const

private

Backward compatibility method to compute default sigma value.

## GetRescaleSchedule()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

const RescaleScheduleType & itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetRescaleSchedule | ( |  | ) | const

inline

Get the multi-resolution rescale schedule.

Definition at line 185 of file itkGenericMultiResolutionPyramidImageFilter.h.

## GetShrinkFactors()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetShrinkFactors | ( | const unsigned int | level,
|  | RescaleFactorArrayType & | shrinkFactors ) const

private

Get shrink factors from m_Schedule for the level.

## GetSigma()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetSigma | ( | const unsigned int | level,
|  | SigmaArrayType & | sigmaArray ) const

private

Get sigmas from m_SmoothingSchedule for the level.

## GetSmoothingSchedule()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual const SmoothingScheduleType & itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::GetSmoothingSchedule | ( |  | ) |

virtual

Get the multi-resolution smoothing schedule.

## IsRescaleUsed()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::IsRescaleUsed | ( |  | ) | const

private

Returns true if rescale has been used in pipeline, otherwise return false.

## IsSmoothingUsed()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::IsSmoothingUsed | ( |  | ) | const

private

Returns true if smooth has been used in pipeline, otherwise return false.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ITK_DISALLOW_COPY_AND_MOVE | ( | GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::itkStaticConstMacro | ( | ImageDimension | ,
|  | unsigned int | ,
|  | TInputImage::ImageDimension | )

ImageDimension enumeration.

## itkStaticConstMacro() [2/2]

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::itkStaticConstMacro | ( | OutputImageDimension | ,
|  | unsigned int | ,
|  | TOutputImage::ImageDimension | )

## New()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

Pointer itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

PrintSelf.

## ReleaseOutputs()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::ReleaseOutputs | ( |  | ) |

protected

Release the output data when the current level is used.

## SetComputeOnlyForCurrentLevel()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetComputeOnlyForCurrentLevel | ( | const bool | _arg | ) |

virtual

Set a control on whether a current level will be used.

## SetCurrentLevel()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetCurrentLevel | ( | unsigned int | level | ) |

virtual

Set the current multi-resolution levels. The current level is clamped to a total number of levels.

## SetNumberOfLevels()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetNumberOfLevels | ( | unsigned int | num | ) |

override

Set the number of multi-resolution levels. The matrices containing the schedule will be resized accordingly. The schedules are populated with default values.

## SetRescaleSchedule()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetRescaleSchedule | ( | const RescaleScheduleType & | schedule | ) |

virtual

Set a multi-resolution rescale schedule. The input schedule must have only ImageDimension number of columns and NumberOfLevels number of rows. For each dimension, the shrink factor must be non-increasing with respect to subsequent levels. This function will clamp shrink factors to satisfy this condition. All shrink factors less than one will also be clamped to the value of 1.

## SetRescaleScheduleToUnity()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetRescaleScheduleToUnity | ( |  | ) |

virtual

Set a multi-resolution rescale schedule with ones.

## SetSchedule()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetSchedule | ( | const ScheduleType & | schedule | ) |

override

Set a multi-resolution schedule. The input schedule must have only ImageDimension number of columns and NumberOfLevels number of rows. For each dimension, the shrink factor must be non-increasing with respect to subsequent levels. This function will clamp shrink factors to satisfy this condition. All shrink factors less than one will also be clamped to the value of 1.

## SetSmoothingSchedule()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetSmoothingSchedule | ( | const SmoothingScheduleType & | schedule | ) |

virtual

Set a multi-resolution smoothing schedule. The input schedule must have only ImageDimension number of columns and NumberOfLevels number of rows. All sigmas less than 0 will also be clamped to the value of 0.

## SetSmoothingScheduleToDefault()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetSmoothingScheduleToDefault | ( |  | ) |

private

Initialize m_SmoothingSchedule to default values for backward compatibility.

## SetSmoothingScheduleToZero()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

virtual void itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetSmoothingScheduleToZero | ( |  | ) |

virtual

Set a multi-resolution rescale schedule with zeros.

## SetupShrinkerOrResampler()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

int itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetupShrinkerOrResampler | ( | const unsigned int | level,
|  | typename SmootherType::Pointer & | smoother,
|  | const bool | sameType,
|  | const InputImageConstPointer & | input,
|  | const OutputImagePointer & | outputPtr,
|  | typename ImageToImageFilterSameTypes::Pointer & | rescaleSameTypes,
|  | typename ImageToImageFilterDifferentTypes::Pointer & | rescaleDifferentTypes )

private

Shrink or Resample image at current level. Returns 1 or 2 if performed, 0 otherwise. This method does not perform execution.

## SetupSmoother()

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::SetupSmoother | ( | const unsigned int | level,
|  | typename SmootherType::Pointer & | smoother,
|  | const InputImageConstPointer & | input )

private

Smooth image at current level. Returns true if performed. This method does not perform execution.

## Field Documentation

## m_ComputeOnlyForCurrentLevel

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::m_ComputeOnlyForCurrentLevel {}

protected

Definition at line 275 of file itkGenericMultiResolutionPyramidImageFilter.h.

## m_CurrentLevel

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

unsigned int itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::m_CurrentLevel {}

protected

Definition at line 274 of file itkGenericMultiResolutionPyramidImageFilter.h.

## m_SmoothingSchedule

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

SmoothingScheduleType itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::m_SmoothingSchedule {}

protected

Definition at line 273 of file itkGenericMultiResolutionPyramidImageFilter.h.

## m_SmoothingScheduleDefined

template<class TInputImage, class TOutputImage, class TPrecisionType = double>

bool itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >::m_SmoothingScheduleDefined {}

protected

Definition at line 276 of file itkGenericMultiResolutionPyramidImageFilter.h.

Generated on 1768596610 for elastix by 1.15.0 |